package com.chenyang.nse.bussiness.engine.infa.basic.webservice;

import com.chenyang.nse.bussiness.commmon.ApplicationConstants;
import java.net.URL;
import javax.xml.namespace.QName;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPBodyElement;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPHeaderElement;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.Dispatch;
import javax.xml.ws.Service;
import javax.xml.ws.Service.Mode;
import org.w3c.dom.Document;

public class PingDIWebService {
   public static String returnStatus(String sessionId, String domain_user, String serverName) throws Exception {
      String ns = ApplicationConstants.webservice_url;
      String wsdlUrl = ApplicationConstants.wsdl_url;
      URL url = new URL(wsdlUrl);
      QName sname = new QName(ns, "DataIntegrationService");
      Service service = Service.create(url, sname);
      Dispatch<SOAPMessage> dispatch = service.createDispatch(new QName(ns, "DataIntegration"), SOAPMessage.class, Mode.MESSAGE);
      SOAPMessage msg = MessageFactory.newInstance("SOAP 1.1 Protocol").createMessage();
      SOAPEnvelope envelope = msg.getSOAPPart().getEnvelope();
      SOAPHeader head = envelope.getHeader();
      QName hename = new QName(ns, "Context", "ns0");
      SOAPHeaderElement hele = head.addHeaderElement(hename);
      hele.addChildElement("SessionId").setValue(sessionId);
      SOAPBody body = envelope.getBody();
      QName ename = new QName(ns, "PingDIServer", "ns0");
      SOAPBodyElement ele = body.addBodyElement(ename);
      SOAPElement di = ele.addChildElement("DIServiceInfo");
      di.addChildElement("DomainName").setValue(domain_user);
      di.addChildElement("ServiceName").setValue(serverName);
      ele.addChildElement("TimeOut").setValue("1000");

      try {
         SOAPMessage response = (SOAPMessage)dispatch.invoke(msg);
         Document doc = response.getSOAPPart().getEnvelope().getBody().extractContentAsDocument();
         if (doc.getElementsByTagName("PingDIServerReturn") == null) {
            return "FAIL";
         } else {
            String str = doc.getElementsByTagName("PingDIServerReturn").item(0).getTextContent();
            return "ALIVE".equals(str) ? "SUCCESS" : "FAIL";
         }
      } catch (Exception e) {
         e.printStackTrace();
         return "FAIL";
      }
   }
}
